# -*- mode: ruby -*-
# vi: set ft=ruby :

# Vagrantfile API/syntax version. Don't touch unless you know what you're doing!
VAGRANTFILE_API_VERSION = "2"

Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
  # All Vagrant configuration is done here. The most common configuration
  # options are documented and commented below. For a complete reference,
  # please see the online documentation at vagrantup.com.

    # Packages vom lokalen Server holen und andere Server via /etc/hosts bekannt machen
    config.vm.provision "shell", inline: <<-SHELL
        # sudo sed -i -e"1i deb http://192.168.43.90/ubuntu bionic main restricted" /etc/apt/sources.list
        echo '127.0.0.1 localhost\n192.168.55.101 web01\n192.168.55.100 db01\n192.168.55.102 master' > /etc/hosts        
SHELL
    
  # Datenbank Server
  config.vm.define "database" do |db|
    db.vm.box = "ubuntu/bionic64"
    db.vm.provider "virtualbox" do |vb|
      vb.memory = "384"  
    end
    db.vm.hostname = "db01"
    db.vm.network "private_network", ip: "192.168.55.100"
    # MySQL Port nur im Private Network sichtbar
    # db.vm.network "forwarded_port", guest:3306, host:3306, auto_correct: false
      db.vm.provision "shell", path: "db.sh"
  end
  
  # Proxy Server - gegen Aussen sichtbar
  config.vm.define "web" do |web|
    web.vm.box = "ubuntu/bionic64"
    web.vm.hostname = "web01"
    web.vm.network "private_network", ip:"192.168.55.101"
    web.vm.network "forwarded_port", guest:80, host:8080, auto_correct: false
    web.vm.provider "virtualbox" do |vb|
      vb.memory = "256"  
    end
    # Braucht es hier nicht, weil Standardseite    
      # web.vm.synced_folder ".", "/var/www/html"  
      # Wird nur in 1. VM gemountet, Fehler?
      web.vm.synced_folder ".", "/vagrant"      
    web.vm.provision "shell", inline: <<-SHELL
        sudo apt-get update
        sudo apt-get -y install debconf-utils apache2 nmap ufw
        sudo debconf-set-selections <<< 'mysql-server mysql-server/root_password password admin'
        sudo debconf-set-selections <<< 'mysql-server mysql-server/root_password_again password admin'
        sudo apt-get -y install php libapache2-mod-php php-curl php-cli php-mysql php-gd mysql-client  
        # Admininer SQL UI 
        sudo mkdir /usr/share/adminer
        sudo wget "http://www.adminer.org/latest.php" -O /usr/share/adminer/latest.php
        sudo ln -s /usr/share/adminer/latest.php /usr/share/adminer/adminer.php
        echo "Alias /adminer.php /usr/share/adminer/adminer.php" | sudo tee /etc/apache2/conf-available/adminer.conf
        sudo a2enconf adminer.conf 
        sudo a2enmod cgi
        sudo cp /vagrant/rest /vagrant/restsql /usr/lib/cgi-bin/ && sudo chown www-data /usr/lib/cgi-bin/rest* && sudo chmod 755 /usr/lib/cgi-bin/rest*
        sudo mkdir -p  /var/www/html/data && sudo chown www-data:www-data /var/www/html/data 
        # Monitoring
        sudo cp /vagrant/cron.root.web01 /var/spool/cron/crontabs/root && sudo chmod 600 /var/spool/cron/crontabs/root
        # Reverse Proxy
        # sudo apt-get install -y libapache2-mod-proxy-html libxml2-dev # obsolet im ApacheBin Packet enthalten
        sudo a2enmod proxy
        sudo a2enmod proxy_html
        sudo a2enmod proxy_http
        # Reverse Proxy
        sudo cp /vagrant/001-reverseproxy.conf /etc/apache2/sites-available/
        sudo ln -s /etc/apache2/sites-available/001-reverseproxy.conf /etc/apache2/sites-enabled/
        # Services restart bzw. reload Konfiguration
        sudo service cron reload
        sudo service apache2 restart 
        # Firewall
        sudo ufw allow 80/tcp 
        sudo ufw allow 22/tcp 
        sudo ufw -f enable    
SHELL
    end  
    
    # Monitoring Server hinter Proxy Server
    config.vm.define "master" do |master|
      master.vm.box = "ubuntu/bionic64"
      master.vm.provider "virtualbox" do |vb|
        vb.memory = "256"  
      end
      master.vm.hostname = "master"
      master.vm.network "private_network", ip: "192.168.55.102"
      # wird nicht mehr benoetigt, weil Reverse Proxy auf web eingerichtet
      #master.vm.network "forwarded_port", guest:80, host:8081, auto_correct: false
        master.vm.synced_folder ".", "/vagrant"      
      master.vm.provision "shell", inline: <<-SHELL
        sudo apt-get update
        sudo apt-get -y install debconf-utils apache2 nmap
        sudo a2enmod cgi        
        sudo cp /vagrant/rest /vagrant/network /usr/lib/cgi-bin/ && sudo chown www-data /usr/lib/cgi-bin/* && sudo chmod 755 /usr/lib/cgi-bin/*
        sudo mkdir -p  /var/www/html/data && sudo chown www-data:www-data /var/www/html/data 
        # OpenLDAP mit Admin UI - http://localhost:8081/phpldapadmin
        export DEBIAN_FRONTEND=noninteractive
        sudo debconf-set-selections <<<'slapd slapd/internal/generated_adminpw password admin'
        sudo debconf-set-selections <<<'slapd slapd/password2 password admin'
        sudo debconf-set-selections <<<'slapd slapd/internal/adminpw password admin'
        sudo debconf-set-selections <<<'slapd slapd/password1 password admin'
        sudo apt-get install -y slapd ldap-utils phpldapadmin    
        # Patch Standarddomain
        sudo sed -i -e's/dc=example,dc=com/dc=nodomain/' /etc/phpldapadmin/config.php    
        sudo service apache2 restart 
        # Firewall 
        sudo ufw allow 22/tcp
        sudo ufw allow from 192.168.55.101 to any port 80 
        sudo ufw -f enable        
SHELL
    end
 end
